<?php


	global $full_system_path;
		$full_system_path = url('', NULL, NULL, TRUE);
     // -------------------------------------------------------------------------------
	global $full_theme_path;
		$full_theme_path = url(path_to_theme().'/', NULL, NULL, TRUE);

	define(NX_C_LINK_NAME, 'c_link');
	define(NX_C_ITEM_NAME, 'c_item');

	drupal_add_js(path_to_theme().'/jquery.cookie.js');
	drupal_add_js(path_to_theme().'/script.js');
	drupal_add_js(path_to_theme().'/nx-collapse.js');
	drupal_add_css(path_to_theme() .'/nx-style.css', 'theme', 'all');
	drupal_add_css(path_to_theme() .'/nx-menus.css', 'theme', 'all');
	if (user_access('access administration pages') || user_access('administer site configuration')){
	    drupal_add_css(path_to_theme() .'/nx-admin.css', 'theme', 'all');
	}

	require_once 'forms/search-block-form-functions.inc.php';
	require_once 'forms/user-login-block-functions.tpl.php';


 /**
 * ------------------------
 * [RU]  
 * ------------------------
 */


    function rewrite_styles() {

     /* [EN] Add name of module in this array if you wont to redeclare styles of selected module.
	After redeclare the css-file must be moved from module folder to the theme folder.
	For example: $modules = array('aggregator');
     */
	$modules = array();

	foreach($modules as $mod_css) {
	    if (module_exists($mod_css)) {
		drupal_add_css(path_to_theme().'/'.$mod_css.'.css', 'module', 'all');
	    }
	}

	$css = drupal_add_css();

	unset($css['all']['module']['modules/node/node.css']);
	unset($css['all']['module']['modules/system/defaults.css']);
	unset($css['all']['module']['modules/system/system.css']);
	unset($css['all']['module']['modules/user/user.css']);
	unset($css['all']['module']['modules/help/help.css']);
	unset($css['all']['module']['modules/system/admin.css']);
	unset($css['all']['module']['modules/block/block.css']);
	unset($css['all']['module']['modules/watchdog/watchdog.css']);
	unset($css['all']['module']['modules/comment/comment.css']);
	unset($css['all']['module']['modules/book/book.css']);
	unset($css['all']['module']['modules/forum/forum.css']);

	foreach ($modules as $mod_css) {
	    if (module_exists($mod_css)) {
		unset($css['all']['module']['modules/'.$mod_css.'/'.$mod_css.'.css']);
		unset($css['all']['module']['sites/all/modules/'.$mod_css.'/'.$mod_css.'.css']);
	    }
	}

	return drupal_get_css($css);
	}


/**
 * ------------------------
 * [EN] Declare the available regions implemented by this engine
 * [RU]   
 * ------------------------
 */


    function n_rebuild_regions() {
	return array(
		'before_head_column_1_region' =>	t('Before head > Column 1'),
		'before_head_column_2_region' =>	t('Before head > Column 2'),
		'before_head_column_3_region' =>	t('Before head > Column 3'),
		'header' =>				t('Head > Column 2'),
		'head_column_3_region' =>		t('Head > Column 3'),
		'left' =>				t('Body > Column 1'),
		'content' =>				t('Body > Column 2 (content)'),
		'right' =>				t('Body > Column 3'),
		'foot_column_1_region' =>		t('Foot > Column 1'),
		'footer_region' =>			t('Foot > Column 2'),
		'foot_column_3_region' =>		t('Foot > Column 3'),
		'techno_bottom_region' =>		t('Techno (bottom)'),
		);
	}


/**
 * ------------------------
 * [EN] Override or insert PHPTemplate variables into the templates
 * [RU]     PHPTemplate  
 * ------------------------
 */


    function _phptemplate_variables($hook, $vars) {
    	global $full_system_path,
		$full_theme_path,
		$base_url,
		$base_path,
		$base_root,
		$user;
	$vars['full_system_path'] = $full_system_path;
	$vars['full_theme_path'] = $full_theme_path;
	$vars['base_url'] = $base_url;
	$vars['base_path'] = $base_path;
	$vars['base_root'] = $base_root;

	if($hook == 'block'){
	}
	
	if($hook == 'page'){
	    $tabs_pri = nx_menu_primary_local_tasks();
	    $tabs_sec = nx_menu_secondary_local_tasks();
	    $vars['tabs_pri'] = $tabs_pri ? '<div class="tabs tabs_pri"><div class="c_clear">&nbsp;</div><ul>' . $tabs_pri . '</ul><div class="c_clear">&nbsp;</div></div>' . "\n" : '';
	    $vars['tabs_sec'] = $tabs_sec ? '<div class="tabs tabs_sec"><div class="c_clear">&nbsp;</div><ul>' . $tabs_sec . '</ul><div class="c_clear">&nbsp;</div></div>' . "\n" : '';
	    $vars['is_admin'] = ($user->uid == 1 ? TRUE : FALSE);
	    $vars['logged_in'] = ($user->uid > 0 ? TRUE : FALSE);
	    $vars['destination'] = nx_get_destination();

	    $nx_body_classes = array();
		$nx_body_classes[] = $vars['is_admin'] ? 'user-admin' : 'user-not_admin';
		$nx_body_classes[] = $vars['logged_in'] ? 'logged_in-yes' : 'logged_in-no';
		$nx_body_classes[] = $vars['is_front'] ? 'page-front' : 'page-not_front';
		$nx_body_classes[] = 'layout-' . $vars['layout'];
		$nx_body_classes[] = 'destination-' . nx_get_destination();
		$nx_body_classes[] = 'universal_destination-' . nx_get_destination(TRUE);
	    $vars['nx_body_classes'] = implode(' ', $nx_body_classes);
	}

	return $vars;
	}


   function nx_get_destination($with_universal_num_params = FALSE){
	$args = explode('/', $_GET['q']);
	for($i=0; $i < count($args); $i++) {
	    $args[$i] = str_replace(array('-',' '), '_', strip_tags($args[$i]));
	    if ($with_universal_num_params) {
	    	if (is_numeric($args[$i])) {
		    $args[$i] = 'n';}}}
	return implode('-', $args);
	}


/**
 * ------------------------
 * [EN] Returns the rendered HTML of the primary and secondary local tasks and simple local task
 * [RU]   ()
 * ------------------------
 */


    function nx_menu_primary_local_tasks() {
	$local_tasks = menu_get_local_tasks();
	$pid = menu_get_active_nontask_item();
	$output = '';
	$num_children = count($local_tasks[$pid]['children']);
	
	if($num_children) {
	    for ($i=0; $i < $num_children; ++$i) {
		$mid = $local_tasks[$pid]['children'][$i];
		$extra_class = '';
		if ($i == 0) {$extra_class.= 'first ';};
		if ($i == $num_children-1) {$extra_class.= 'last ';};
		$output .= theme('menu_local_task', $mid, menu_in_active_trail($mid), TRUE, $extra_class);
	    }
	}
	return $output;
	}


    function nx_menu_secondary_local_tasks() {
	$local_tasks = menu_get_local_tasks();
	$pid = menu_get_active_nontask_item();
	$output = '';

	if (count($local_tasks[$pid]['children'])) {
	     foreach ($local_tasks[$pid]['children'] as $mid) {
		if (menu_in_active_trail($mid) && count($local_tasks[$mid]['children']) > 1) {
		    $num_children = count($local_tasks[$mid]['children']);
		    for ($i = 0; $i < $num_children; ++$i) {
			$cid = $local_tasks[$mid]['children'][$i];
			$extra_class = '';
			if ($i == 0) {$extra_class.= 'first ';};
			if ($i == $num_children-1) {$extra_class.= 'last ';};
			$output .= theme('menu_local_task', $cid, menu_in_active_trail($cid), FALSE, $extra_class);
		    }
		}
	    }
	}
	return $output;
	}


   function phptemplate_menu_local_task($mid, $active, $primary, $extraclass = '') {
	return '<li class="' . NX_C_ITEM_NAME . ' ' . $extraclass . ($active ? 'active' : '') . '">'. menu_item_link($mid) ."</li>\n";
	}


/**
 * ------------------------
 * [EN] Return a themed set of links
 * ------------------------
 */


    function phptemplate_links($links, $attributes = array('class' => 'links'), $cover = array(
		'outer_prefix' => '',
		'inner_prefix' => '',
		'inner_suffix' => '',
		'outer_suffix' => '<span class="c_bounder">&nbsp;</span>')) {
	$output = '';
	if (count($links) > 0) {
	    $output = '<ul'. drupal_attributes($attributes) .'>';
	    $num_links = count($links);
	    $i = 1;
	    foreach ($links as $key => $link) {
		$class = $key;
	     // [EN] Automatically add a class to each link and also to each LI
		if (isset($link['attributes']) && isset($link['attributes']['class'])) {
		    $link['attributes']['class'] .= ' ' . $key;
		} else {
		    $link['attributes']['class'] = $key;
		}
	     // [EN] Add first and last classes to the list of links to help out themers.
		$extra_class = '';
		if ($i == 1) {$extra_class .= 'first ';}
		if ($i == $num_links) {$extra_class .= 'last ';}
		$output .= '<li '. drupal_attributes(array('class' => $extra_class . $class)) .'>';
	     // [EN] Is the title HTML?
		$html = isset($link['html']) && $link['html'];
	     // [EN] Initialize fragment and query variables.
		$link['query'] = isset($link['query']) ? $link['query'] : NULL;
		$link['fragment'] = isset($link['fragment']) ? $link['fragment'] : NULL;
		if (isset($link['href'])) {
		 // -------------------------------------------------------
		    $link['title'] = $cover['inner_prefix'] . ($html ? $link['title'] : check_plain($link['title'])) . $cover['inner_suffix'];
		    $output .= $cover['outer_prefix'];
		    $output .= l($link['title'], $link['href'], $link['attributes'], $link['query'], $link['fragment'], FALSE, TRUE);
		    $output .= $cover['outer_suffix'];
		 // -------------------------------------------------------
		}
		else if ($link['title']) {
		 // [EN] Some links are actually not links, but we wrap these in <span> for adding title and class attributes
		 // [RU]      ,    span         
		    if (!$html) {$link['title'] = check_plain($link['title']);}
		 // -------------------------------------------------------
		    $output .= $cover['outer_prefix'].'<span'. drupal_attributes($link['attributes']) .'>'.$cover['inner_prefix'].$link['title'].$cover['inner_suffix'].'</span>'.$cover['outer_suffix'];
		 // -------------------------------------------------------
		}
		$i++;
		$output .= "</li>\n";}
	    $output .= '</ul>';}
	return $output;
	}


/**
 * ------------------------
 * [EN] Return a themed set of status and/or error messages. The messages are grouped by type
 * [RU]   
 * ------------------------
 */


    function phptemplate_status_messages($display = NULL) {
	$output = '';
	foreach (drupal_get_messages($display) as $type => $messages) {
	    $output .= "<div class=\"messages message-$type\">\n";
	    if (count($messages) > 1) {
		$output .= " <ul>\n";
		foreach ($messages as $message) {
		    $output .= '  <li>'. wordwrap($message, 50, "\n", TRUE) ."</li>\n";}
		$output .= " </ul>\n";}
	    else {
		$output .= wordwrap($messages[0], 50, "\n", TRUE);}
	    $output .= "</div>\n";}
	return $output;
	}


/**
 * ------------------------
 * [EN] Return a themed help message
 * [RU]   
 * ------------------------
 */


    function phptemplate_help() {
	if ($help = menu_get_active_help()) {
	    if (strlen($help) > 10) {return '<div class="help">'. $help .'</div>';}
	}
	}


/**
 * ------------------------
 * [EN] Return a themed breadcrumb trail
 * [RU]  -
 * ------------------------
 */


    function phptemplate_breadcrumb($breadcrumb) {
	if (!empty($breadcrumb)) {
	    $last_item = &$breadcrumb[count($breadcrumb)-1];
	    $last_item = str_replace('c_link', 'c_link last', $last_item);
	    return '<div class="breadcrumb">' . implode('<span class="gt">&gt;</span>', $breadcrumb) . '</div>';
	}
	}


/**
 * ------------------------
 * [EN] Format a group of form items
 * [RU]   fieldset
 * ------------------------
 */


    function phptemplate_fieldset($element) {
	if($element['#collapsible']) {
	    if(!isset($element['#attributes']['class'])) {
		$element['#attributes']['class'] = '';
	    }
	    $element['#attributes']['class'] .= ' collapsible';
	    if($element['#collapsed']) {
		$element['#attributes']['class'] .= ' collapsed';
	    }
	}
	return _phptemplate_callback('nx-fieldset', array(
		'attributes' => drupal_attributes($element['#attributes']),
		'title' => ($element['#title'] ? $element['#title'] : ''),
		'description' => ($element['#description'] ? $element['#description'] : ''),
		'children' => $element['#children'],
		'value' => $element['#value'],
		));
	}


/**
 * ------------------------
 * [EN] Allow themable wrapping of all comments
 * [RU]      
 * ------------------------
 */

	
    function phptemplate_comment_wrapper($content, $type = null) {
	if (strlen($content) == 0) {return;}
	static $node_type;
	if (isset($type)) $node_type = $type;
	if (!$content || $node_type == 'forum') {return '<div id="comments" class="c_all_comments">'. $content .'</div>';}
	else {return '<div id="comments" class="c_all_comments"><h2 class="c_all_comments_title">'. t('Comments') .'</h2>'. $content .'</div>';}
	}


/**
 * ------------------------
 * [EN] Return a set of blocks available for the current user
 * [RU]  
 * ------------------------
 */		


    function phptemplate_blocks($region) {
	$output = '';
	if ($list = block_list($region)) {
	    $blocks_num = count($list);
	    $i = 1;
	    foreach ($list as $key => $block) {
	     // where $key is "module_delta"
		if ($blocks_num == 1) {$block->nx_block_extra_class = 'single';}
		else {
		    if ($i == 1) {$block->nx_block_extra_class = 'first';}
		    if ($i == $blocks_num) {$block->nx_block_extra_class = 'last';}}
		$block->nx_block_num = $i++;
		$output .= theme('block', $block);
	    }
	}
     // [EN] Add any content assigned to this region through drupal_set_content() calls.
	$output .= drupal_get_content($region);
	return $output;
	}


/**
 * ------------------------
 * [EN] Return a themed table
 * [RU]   .table  <TABLE>  .tc-{_}  <TD>  <TH>
 * ------------------------
 */


     function nx_set_column_number(&$cell, $num){
	if (!is_array($cell)) {$cell = array('class' => '','data' => $cell);}
	if (!isset($cell['class'])) {$cell['class'] = '';}
	$cell['class'].= ' tc-'.$num;
	}

	
    function phptemplate_table($header, $rows, $attributes = array(), $caption = NULL) {

     // -----------------------------------------------
	if(isset($attributes['class'])) {$attributes['class'].= ' table';}
	else {$attributes['class'] = 'table';}
     // -----------------------------------------------

	$output = '<table'. drupal_attributes($attributes) .">\n";
	if (isset($caption)) {
	    $output .= '<caption>'. $caption ."</caption>\n";
	}

     // [EN] Format the table header:
     // [RU]    (THEAD):
	if (count($header)) {
	    $ts = tablesort_init($header);
	    $output .= (count($rows) ? ' <thead><tr>' : ' <tr>');
	    $i = 0;
	    foreach ($header as $cell) {
		$cell = tablesort_header($cell, $header, $ts);
	     // -----------------------------------------------
		nx_set_column_number(&$cell,++$i);
	     // -----------------------------------------------
		$output .= _theme_table_cell($cell, TRUE);}
	    $output .= (count($rows) ? " </tr></thead>\n" : "</tr>\n");
	}

     // [EN] Format the table rows:
     // [RU]    (TBODY):
	if (count($rows)) {
	    $output .= "<tbody>\n";
	    $flip = array('even' => 'odd', 'odd' => 'even');
	    $class = 'even';
	    foreach ($rows as $number => $row) {
		$attributes = array();
	     // [EN] Check if we're dealing with a simple or complex row
	     // [RU]            
		if (isset($row['data'])) {
		    foreach ($row as $key => $value) {
			if ($key == 'data') {$cells = $value;}
			else {$attributes[$key] = $value;}}}
		else {$cells = $row;}

	     // [EN] Add odd/even class
	     // [RU]   odd/even
		$class = $flip[$class];
		if (isset($attributes['class'])) {$attributes['class'] .= ' '. $class;}
		else {$attributes['class'] = $class;}

	     // [EN] Build row
	     // [RU]  
		$output .= ' <tr'. drupal_attributes($attributes) .'>';
		$i = 0;
		foreach ($cells as $cell) {
		    $cell = tablesort_cell($cell, $header, $ts, $i++);
		 // -----------------------------------------------
		    nx_set_column_number(&$cell,$i);
		 // -----------------------------------------------
		    $output .= _theme_table_cell($cell);}
		$output .= " </tr>\n";
	    }
	    $output .= "</tbody>\n";
	}
	$output .= "</table>\n";
	return '<div class="table_cover">'.$output.'</div>';
	}


/**
 * ------------------------
 * [EN] Generate the HTML output for a menu
 * [RU]  
 * ------------------------
 */


    function phptemplate_menu_tree($pid = 1) {
	static $depth;
	$depth++;
	$menu = menu_get_menu();
	$output = '';
     // -----
	if (isset($menu['visible'][$pid]) && $menu['visible'][$pid]['children']) {
	    $num_children = count($menu['visible'][$pid]['children']);
	    for ($i=0; $i < $num_children; ++$i) {
		$c_child_id = $menu['visible'][$pid]['children'][$i];
		$c_child = $menu['visible'][$c_child_id];
		$c_child_type = isset($c_child['type']) ? $c_child['type'] : NULL;
		$c_child_children = isset($c_child['children']) ? $c_child['children'] : NULL;
	     // -------------------------------------------------------------
		$flags = array();
		if ($i == 0) {$flags['first'] = TRUE;}
		if ($i == $num_children-1) {$flags['last'] = TRUE;}
		if (menu_in_active_trail($c_child_id)) {$flags['in_active_trail'] = TRUE;}
		$flags['depth'] = $depth;
	     // -------------------------------------------------------------
		$output .= theme('menu_item',
				$c_child_id,
				(menu_in_active_trail($c_child_id)||($c_child_type&MENU_EXPANDED)) ? theme('menu_tree', $c_child_id) : '',
				count($c_child_children) == 0,
				$flags);}}
     // -----
	$depth--;
	if ($output&&$menu['visible'][$pid]['pid']==0) {return "\n<ul class=\"c_menu\">".$output."\n</ul>\n<div class=\"c_clear\">&nbsp;</div>\n";}
	if ($output) {return "\n<ul class=\"c_menu\">".$output."\n</ul>\n";}
	}


    function phptemplate_menu_item($mid, $children = '', $leaf = TRUE, $flags = array()) {
	$is_collapsed = ($leaf ? 'leaf' : ($children ? 'expanded' : 'collapsed'));
	$class = NX_C_ITEM_NAME;
	$class.= ' ' . $is_collapsed;
	$class.= (isset($flags['in_active_trail']) ? ' active-trail': '');
	$class.= (isset($flags['first']) ? ' first': '');
	$class.= (isset($flags['last']) ? ' last': '');
	$class.= (isset($flags['depth']) ? ' depth_' . $flags['depth'] : '');
	$class.= (isset($flags['depth']) ? ' ' . $is_collapsed . '-depth_' . $flags['depth'] : '');
	return '<li class="'. $class .'">'. menu_item_link($mid) . $children ."</li>\n";
	}


    function phptemplate_menu_item_link($item, $link_item, $cover = array(
		'outer_prefix' => '',
		'inner_prefix' => '<span><span>',
		'inner_suffix' => '</span></span>',
		'outer_suffix' => '')) {
	$item['title'] = $cover['inner_prefix'] . check_plain($item['title']) . $cover['inner_suffix'];
	$attributes = !empty($item['description']) ? array('title' => $item['description']) : array();
	$attributes['class'] = NX_C_LINK_NAME;
	return $cover['outer_prefix'] . l($item['title'], $link_item['path'], $attributes, isset($item['query']) ? $item['query'] : NULL, NULL, FALSE, TRUE) . $cover['outer_suffix'];
	}


/**
 * ------------------------
 * [EN] Prepares the links to children (TOC) and forward/backward navigation for a node presented as a book page
 * [RU]  book navigation
 * ------------------------
 */


    function phptemplate_book_navigation($node) {
	$output = '';

	if ($node->nid) {
	    $tree = book_tree($node->nid);
	    $prev = book_prev($node);
	    $next = book_next($node);

	    if ($node->parent) {
		drupal_add_link(array('rel' => 'up', 'href' => url('node/'. $node->parent)));
		$up_link = l(t('up'), 'node/'. $node->parent, array('class' => 'up_link', 'title' => t('Go to parent page')));}
	    if ($prev) {
		drupal_add_link(array('rel' => 'prev', 'href' => url('node/'. $prev->nid)));
		$prev_link = l($prev->title, 'node/'. $prev->nid, array('class' => 'prev_link', 'title' => t('Go to previous page')));}
	    if ($next) {
		drupal_add_link(array('rel' => 'next', 'href' => url('node/'. $next->nid)));
		$next_link = l($next->title, 'node/'. $next->nid, array('class' => 'next_link', 'title' => t('Go to next page')));}

	    if (isset($tree) || $up_link || $prev_link || $next_link) {
		$output.= _phptemplate_callback('nx-book_navigator', array(
			'tree' => $tree,
			'up_link' => $up_link,
			'prev_link' => $prev_link,
			'next_link' => $next_link,
			));
	    }
	}
	return $output;
	}


/**
 * ------------------------
 * [EN] Theme the forum
 * [RU]  
 * ------------------------
 */


    function phptemplate_forum_topic_list($tid, $topics, $sortby, $forum_per_page) {
	$output = theme_forum_topic_list($tid, $topics, $sortby, $forum_per_page);
	$output = str_replace(' field=""', ' ', $output);
     // [EN] Remove 'field=""' from THEAD
     // [RU]   THEAD  'field=""'
	return $output;
	}


    function phptemplate_forum_topic_navigation($node) {
	$output = '';
     // [EN] Get previous and next topic
     // [RU]     
	$sql = "SELECT n.nid, n.title, n.sticky, l.comment_count, l.last_comment_timestamp FROM {node} n INNER JOIN {node_comment_statistics} l ON n.nid = l.nid INNER JOIN {term_node} r ON n.nid = r.nid AND r.tid = %d WHERE n.status = 1 AND n.type = 'forum' ORDER BY n.sticky DESC, ". _forum_get_topic_order_sql(variable_get('forum_order', 1));
	$result = db_query(db_rewrite_sql($sql), $node->tid);

	$stop = 0;
	while ($topic = db_fetch_object($result)) {
	    if ($stop == 1) {
		$next = new stdClass();
		$next->nid = $topic->nid;
		$next->title = $topic->title;
		break;
	    }
	    if ($topic->nid == $node->nid) {
		$stop = 1;
	    } else {
		$prev = new stdClass();
		$prev->nid = $topic->nid;
		$prev->title = $topic->title;
	    }
	}

	if ($prev || $next) {
	    $output.= _phptemplate_callback('nx-book_navigator', array(
			'tree' => NULL,
			'up_link' => NULL,
			'prev_link' => ($prev ? l($prev->title, 'node/'. $prev->nid, array('class' => 'prev_link', 'title' => t('Go to previous forum topic'))) : ''),
			'next_link' => (!empty($next) ? l($next->title, 'node/'. $next->nid, array('class' => 'next_link', 'title' => t('Go to next forum topic'))) : ''),
			));
	}
	return $output;
	}

